package com.tofly.feesapi.wxgl.wechatofficalacctmgt.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.WxWzjbsq;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.dto.WxCommonDto;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.vo.WxWzjbsqVo;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.service.WxWzjbsqService;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 微信-违章举报申请
 */
@RestController
@RequestMapping("/wxwzjbsq")
@Api(tags="微信-违章举报申请接口")
public class WxWzjbsqController {

    @Autowired
    private WxWzjbsqService wxWzjbsqService;

    @GetMapping("/getpage")
    @ApiOperation(value = "自定义分页查询")
    public ResultRespone<Page<WxWzjbsqVo>> getWxWzjbsqPage(Page page, @ModelAttribute WxCommonDto dto) {
        ResultRespone<Page<WxWzjbsqVo>> resultRespone = new ResultRespone<>();
        try {
            Page<WxWzjbsqVo> wxPage = wxWzjbsqService.getWxWzjbsqPage(page, dto);
            resultRespone.setCode(1);
            resultRespone.setResult(wxPage);
        } catch (RuntimeException e) {
            resultRespone.setCode(-1);
            resultRespone.setMessage(e.getMessage());
        }
        return resultRespone;
    }

    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getWxWzjbsqPage(Page page, @ModelAttribute WxWzjbsq wxWzjbsq) {
      return ResultRespone.success(wxWzjbsqService.page(page, Wrappers.query(wxWzjbsq)));
    }


    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("id" ) String id) {
      return ResultRespone.success(wxWzjbsqService.getById(id));
    }

    @ApiOperation(value = "新增微信-违章举报申请")
    @PostMapping
    public ResultRespone save(@RequestBody WxWzjbsq wxWzjbsq) {
      return ResultRespone.success(wxWzjbsqService.save(wxWzjbsq));
    }


    @ApiOperation(value = "修改微信-违章举报申请")
    @PutMapping
    public ResultRespone updateById(@RequestBody WxWzjbsq wxWzjbsq) {
      return ResultRespone.success(wxWzjbsqService.updateById(wxWzjbsq));
    }


    @ApiOperation(value = "通过ID删除微信-违章举报申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{id}" )
    public ResultRespone removeById(@PathVariable String id) {
      return ResultRespone.success(wxWzjbsqService.removeById(id));
    }

    @ApiOperation(value = "通过ID批量删除微信-违章举报申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(wxWzjbsqService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
